/*
                        Copyright (c) 1994 by
                        Advanced Visual Systems Inc.
                        All Rights Reserved
        
        This software comprises unpublished confidential information of
        Advanced Visual Systems Inc. and may not be used, copied or made
        available to anyone, except in accordance with the license
        under which it is furnished.
        
        This file is under Perforce control
        $Id: //depot/express/fcs992/include/avs/ne.h#1 $
*/

/* Network Editor header file */

/*---------------------------------------------------------------------*/

/* Prevent the contents of this file from being included more than once */

#ifndef _NE_H_INCLUDED
#define _NE_H_INCLUDED

/*---------------------------------------------------------------------*/

/* Header files */

#include <avs/ne_type.h>

/*--------------------------------------------------------------------*/
/*                       Function prototypes                          */
/*--------------------------------------------------------------------*/

#ifdef __cplusplus  /* Do not leave open across includes */
extern "C" {        /* For C++ V2.0 */
#endif

/*--------------------------------------------------------------------*/
/*                          API functions                             */
/*--------------------------------------------------------------------*/

/* From api.c */

int
NEget_selected_objs PTARGS((
    OMobj_id  ne_obj_id,
    OMobj_id  **objs,
    int       *num_objs));

/*--------------------------------------------------------------------*/
/*                       Internal functions                           */
/*--------------------------------------------------------------------*/

NEobj_disp *
NEcreate_obj_disp PTARGS((
    NEshell_info  *shell_info,
    WTsys_wind   parent_sys_wind,
    OMobj_id      obj_id,
    NEdisp_type   *type,
    NEgeom_spec   *geom_spec));

NEobj_disp *
NEcreate_sub_obj_disp PTARGS((
    NEobj_disp   *parent,
    OMobj_id     obj_id,
    NEdisp_type  *type,
    NEgeom_spec  *geom_spec));

void NEdestroy_obj_disp PTARGS((NEobj_disp *));

void NErealize_obj_disp PTARGS((NEobj_disp *obj_disp));

int NEupd_subobjs PTARGS((NEobj_disp *obj_disp));

void NEdestroy_subs PTARGS((NEobj_disp *));

void NEupd_conns PTARGS((NEobj_disp *obj_disp));

void NEgen_poss_conns PTARGS((NEobj_disp *obj_disp, int icon, int port, 
                              int inout, int connect));

void
NEutil_draw_poss_conns PTARGS((
    NEobj_disp  *obj_disp,
    int         draw));

void NEdestroy_conns PTARGS((NEobj_disp *obj_disp));

void NEdestroy_poss_conns PTARGS((NEobj_disp *obj_disp));

void NEdestroy_stubs PTARGS((NEobj_disp *obj_disp));

void NEtoggle_disp_mode PTARGS((NEobj_disp *obj_disp));

int  NEis_obj_destroyable PTARGS((NEobj_disp *obj_disp));

void NEuser_destroy_obj PTARGS((NEobj_disp *obj_disp));

void NEuser_destroy_objs PTARGS((int nobjs, NEobj_disp *obj_disp[]));

int NEmake_obj_disp_rw PTARGS((NEobj_disp *obj_disp));

int NEobj_sub_outline PTARGS((NEobj_disp *obj_disp,WTregion *reg));

int NEutil_graph_disp_subobjs PTARGS((NEobj_disp *obj_disp));

void NEutil_port_size PTARGS((int num_ports, WTcoord min, WTcoord max, 
                              WTcoord *incr, WTcoord *pad));

void NEutil_draw_ports PTARGS((NEobj_disp *obj_disp, int horiz,
                               WTcoord min_x, WTcoord min_y, 
                               WTcoord max_x, WTcoord max_y));

void NEutil_draw_conns PTARGS((NEobj_disp *obj_disp, int draw)); 

void NEutil_draw_marker PTARGS((WTwind *wind, WTcolor color,
                               WTcoord x, WTcoord y,
                               int in, WTcoord size, int horiz));

void NEpport_get_port_dims PTARGS((NEobj_disp *obj_disp, NEport *port,int ind,
                                  int inout, WTcoord *x, WTcoord *y, 
                                  WTcoord *size, int *horiz, 
                                  NEobj_disp *par_disp));

void NElport_get_port_dims PTARGS((NEobj_disp *obj_disp, NEport *port,int ind,
                                  int inout, WTcoord *x, WTcoord *y, 
                                  WTcoord *size, int *horiz, 
                                  NEobj_disp *par_disp));

int NEutil_get_port_from_xy PTARGS((NEobj_disp *obj_disp, WTcoord x,
                                    WTcoord y,
                                    int *inout, int *port, 
                                    NEobj_disp *par_obj_disp));

int
NElport_guts PTARGS((
    NEobj_disp  *obj_disp,
    NEport      *port,
    int         ind,
    int         inout, 
    WTcoord    *x,
    WTcoord    *y,
    WTcoord    *size,
    int         *horiz,
    NEobj_disp  *par_obj_disp));

OMobj_name NEget_unique_name PTARGS((OMobj_id new_obj, 
                                      OMobj_id new_parent, int *));

char *
NEget_obj_text_info PTARGS((
    NEobj_disp             *obj_disp,
    WTcoord               *text_x,
    WTcoord               *text_y,
    WTcoord               *pixmap_x,
    WTcoord               *pixmap_y,
    WTtext_justification  *justification,
    char                   *buf,
    int                    maxsize));

WTwind *
NEget_parent_wind PTARGS((
    NEobj_disp  *obj_disp));

void
NEdelete_child PTARGS((
    NEobj_disp  *child,
    int         destroy));

NEobj_disp *
NEget_resize_disp PTARGS((
    NEobj_disp  *obj_disp));

NEobj_disp *
NEfind_sub_obj_disp PTARGS((
    NEobj_disp  *obj_disp,
    OMobj_id    child_id));

void
NEmap_buttons PTARGS((
    NEobj_disp  *obj_disp,
    int         map));

void
NErequest_default_geom PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec,
    int          *request_config));

void NEget_obj_port_vals PTARGS((OMobj_id obj_id, int port_vals[2]));

void NEmodify_port_levels PTARGS((OMobj_id obj_id, int iport, int oport));

int NEgraph_init PTARGS((NEobj_disp *obj_disp, NEgeom_spec *geom_spec, 
                          int conf));

void NEgraph_realize PTARGS((NEobj_disp *obj_disp));

void NEgraph_config PTARGS((NEobj_disp *));

int NEgraph_prop_changed PTARGS((NEobj_disp *));

WTwind *
NEgraph_get_parent_wind PTARGS((
    NEobj_disp  *obj_disp));

void
NEgraph_delete_child PTARGS((
    NEobj_disp  *obj_disp,
    NEobj_disp  *child,
    int         destroy));

int
NEgraph_resize_query PTARGS((
    NEobj_disp  *obj_disp,
    NEobj_disp  *sub_disp));

void
NEgraph_geom_spec_req PTARGS((
    NEobj_disp   *obj_disp,
    NEobj_disp   *chld,
    NEgeom_spec  *spec,
    int          *conf));

int
NEgraph_config_req PTARGS((
    NEobj_disp   *obj_disp,
    NEobj_disp   *chld,
    NEgeom_spec  *spec));

int NEgraph_get_port_from_xy PTARGS((NEobj_disp *obj_disp, 
        WTcoord press_x, WTcoord press_y, int *press_inout, int *press_port,
	int *inside));

int NEgraph_upd_subobjs PTARGS((NEobj_disp *));

NEconn *NEgraph_pick_conn PTARGS((NEobj_disp *obj_disp,
                                  WTcoord x, WTcoord y));

int NElist_init PTARGS((NEobj_disp *obj_disp, NEgeom_spec *geom_spec, 
                        int conf));
int NEexport_list_init PTARGS((NEobj_disp *obj_disp, NEgeom_spec *geom_spec, 
                        int conf));
int NEexport_list_cleanup PTARGS((NEobj_disp *obj_disp,
                           NEcleanup_mode  mode));

void NElist_config PTARGS((NEobj_disp *));

int NElist_upd_subobjs PTARGS((NEobj_disp *));

int
NElist_config_req PTARGS((
    NEobj_disp   *obj_disp,
    NEobj_disp   *chld,
    NEgeom_spec  *spec));

WTwind *
NElist_get_parent_wind PTARGS((
    NEobj_disp  *obj_disp));

void
NElist_geom_spec_req PTARGS((
    NEobj_disp   *obj_disp,
    NEobj_disp   *chld,
    NEgeom_spec  *spec,
    int          *conf));

void NEscroll_to_descendant PTARGS((NEobj_disp *));

void NElabel_expose PTARGS((WTwind *wind, WTevent *event, void *arg));

void NElabel_highlight_entlv PTARGS((WTwind *wind, WTevent *event, void *arg));

int NEicon_init PTARGS((NEobj_disp *obj_disp, NEgeom_spec *geom_spec, 
                        int conf));

void NEicon_realize PTARGS((NEobj_disp *obj_disp));

char *
NEicon_get_text_info PTARGS((
    NEobj_disp             *obj_disp,
    WTcoord               *text_x,
    WTcoord               *text_y,
    WTcoord               *pixmap_x,
    WTcoord               *pixmap_y,
    WTtext_justification  *justification,
    char                   *buf,
    int                    maxsize));

int NElink_init PTARGS((NEobj_disp *,NEgeom_spec *,int));

void NEinsert_link PTARGS((NEobj_disp *,NEconn *,float,float));

void NEdelete_link PTARGS((NEobj_disp *));

void NEsub_port_expose PTARGS((WTwind *wind, WTevent *event, void *arg));

void NEconn_expose PTARGS((WTwind *wind, WTevent *event, void *arg));

int NEwind_init PTARGS((NEobj_disp *, NEgeom_spec *geom_spec, int));

void NEresize_button PTARGS((NEobj_disp *obj_disp, WTevent *event));

void NEwind_button PTARGS((WTwind *wind, WTevent *event, void *arg));

void NEwind_realize PTARGS((NEobj_disp *obj_disp));

int NEwind_cleanup PTARGS((NEobj_disp *obj_disp,
                           NEcleanup_mode  mode));

void NEwind_port_dims PTARGS((NEobj_disp *obj_disp, NEobj_disp *par_disp, 
                              int inout, int *horiz, 
                              WTcoord *min, WTcoord *max, WTcoord *loc));

int NEwind_prop_changed PTARGS((NEobj_disp *));

int NEwind_upd_subobjs PTARGS((NEobj_disp *));

char *
NEwind_get_text_info PTARGS((
    NEobj_disp             *obj_disp,
    WTcoord               *text_x,
    WTcoord               *text_y,
    WTcoord               *pixmap_x,
    WTcoord               *pixmap_y,
    WTtext_justification  *justification,
    char                   *buf,
    int                    maxsize));

NEobj_disp *
NEwind_get_resize_disp PTARGS((
    NEobj_disp  *obj_disp,
    NEobj_disp  *sub_disp));

NEobj_disp *
NEwind_find_sub_obj_disp PTARGS((
    NEobj_disp  *obj_disp,
    OMobj_id    child_id));

void NEinit_install_dirs PTARGS((void));

int NEutil_get_port_from_xy PTARGS((NEobj_disp *obj_disp, WTcoord x,
                                   WTcoord y,
                              int *inout, int *port, NEobj_disp *par_obj_disp));

void NEport_draw_ports PTARGS((NEobj_disp *, NEobj_disp *));

int NEwind_get_port_from_xy PTARGS((NEobj_disp *obj_disp, 
        WTcoord press_x, WTcoord press_y, int *press_inout, int *press_port,
	int *inside));

void NEpport_get_port_dims PTARGS((NEobj_disp *obj_disp, NEport *port,int index,
                                   int inout, WTcoord *x, WTcoord *y, 
                                   WTcoord *size, int *horiz, 
                                   NEobj_disp *par_obj_disp));

void NElport_get_port_dims PTARGS((NEobj_disp *obj_disp, NEport *port,int index,
                                   int inout, WTcoord *x, WTcoord *y, 
                                   WTcoord *size, int *horiz, 
                                   NEobj_disp *par_obj_disp));

void NEgraph_port_dims PTARGS((NEobj_disp *obj_disp, NEobj_disp *par_disp, 
                              int inout, int *horiz, 
                              WTcoord *min, WTcoord *max, WTcoord *loc));

void NElist_realize PTARGS((NEobj_disp *obj_disp));

void NElist_restack PTARGS((NEobj_disp *));

NEdisp_type *NEget_disp_type PTARGS((NEobj_disp *obj_disp, int *maximize));

void NEadd_disp_type PTARGS((NEdisp_type *type));

void NE_callback PTARGS((OMobj_id, OMobj_id, unsigned int, void *));

int NEupd_ports PTARGS((NEobj_disp *));

int
NEget_subports PTARGS((
    OMobj_id  obj_id,
    OMobj_id  cache_id,
    NEport    *ports,
    int       first,
    int       max,
    int       depth,
    int	      orig,
    int	      export_list));

void
NEdelete_subports PTARGS((
    NEobj_disp  *obj_disp));

void
NEupdate_port_id_rw PTARGS((
    NEobj_disp  *obj_disp,
    NEport	*port));

void
NEcheck_my_port PTARGS((
    NEobj_disp  *obj_disp));

int NEset_conn PTARGS((NEobj_disp *, int, int, int, int, int));

int NEis_disp_descendant PTARGS((NEobj_disp *, NEobj_disp *));

void NEset_obj_disp_decor PTARGS((
    NEobj_disp  *obj_disp,
    int          flush));

int NE_upd_port_color PTARGS((NEport *, OMobj_id));

void NEinstall_hourglass PTARGS((NEobj_disp  *obj_disp));

void NEinstall_hourglass_with_sys_wind PTARGS((WTsys_wind  sys_wind));

int NEget_port_dims PTARGS((
    NEobj_disp  *obj_disp,
    int          port_index,
    int          inout,
    WTcoord     *x,
    WTcoord     *y,
    WTcoord     *size,
    int          *horiz,
    NEobj_disp  *par_obj_disp));

void NEinit_help PTARGS((void));

int NEdisplay_help PTARGS((
    NEobj_disp  *obj_disp,
    char        *topic,
    int         flag_errors));

void NEterminate_help PTARGS((
    NEshell_info  *shell_info));

void
NEdisplay_obj_menu PTARGS((
    NEobj_disp  *obj_disp,
    int         x,
    int         y,
    int         port_hit,
    int         inout,
    int         port_index));

void
NEgraph_menu_button PTARGS((
    WTwind *wind,
    WTevent *event,
    void *arg));

int
NEhit_resize PTARGS((
    NEobj_disp     *obj_disp,
    WTevent        *event));

void
NEwind_get_text_pos PTARGS((
    NEobj_disp             *obj_disp,
    WTcoord               *text_x,
    WTcoord               *text_y,
    WTcoord               *pixmap_x,
    WTcoord               *pixmap_y,
    WTtext_justification  *justification));

char *
NEget_obj_name_and_value_string PTARGS((
    NEobj_disp  *obj_disp,
    char        *buf,
    int         maxsize));

char *
NEget_obj_path_string PTARGS((
    NEobj_disp  *obj_disp,
    char        *buf,
    int         maxsize));

char *
NEget_obj_mode_and_name PTARGS((
    NEobj_disp  *obj_disp,
    char        *buf,
    int         maxsize));

void
NEget_pixmap_info PTARGS((
    NEobj_disp      *obj_disp,
    char            **name,
    WTpixmap_type  *type));

void
NE_draw_xor_box PTARGS((
    WTwind     *wind,
    WTcoord    x1,
    WTcoord    y1,
    WTcoord    x2, 
    WTcoord    y2,
    int         draw));

/* Object finder functions */

void NEpopup_object_finder PTARGS((
    NEobj_disp  *obj_disp));

void NEhide_object_finder PTARGS((
    NEobj_disp  *obj_disp));

NEdescendant *NEfind_matching_descendants PTARGS((
    NEobj_disp  *obj_disp,
    char         *string,
    int          mode,
    int          libs,
    int          *num_descendants));

void NEfree_descendant_list PTARGS((
    NEdescendant  *descendants,
    int           num_descendants));

NEobject_finder NEcreate_object_finder PTARGS((
    NEobj_disp  *obj_disp));

void NEupdate_object_finder PTARGS((
    NEobject_finder  finder,
    NEobj_disp       *obj_disp));

void NEdisplay_object_finder PTARGS((
    NEobject_finder  finder));

void NEshow_descendant PTARGS((
    NEobj_disp        *obj_disp,
    NEdescendant_list  list));

/* Property editor functions */

void
NEpopup_properties_editor PTARGS((
    NEobj_disp  *obj_disp));

void
NEhide_properties_editor PTARGS((
    NEobj_disp  *obj_disp));

NEprop_list
NEget_defined_props PTARGS((
    int  *num_props));

NEobj_prop_list
NEget_obj_props PTARGS((
    NEobj_disp   *obj_disp,
    NEprop_list  global_props,
    int          num_global_props,
    int          *num_props));

void
NEset_obj_props PTARGS((
    NEobj_disp       *obj_disp,
    NEobj_prop_list  props,
    int              num_props));

int
NEadd_obj_prop PTARGS((
    NEobj_prop_list  *props,
    int              *num_props,
    NEprop_list      global_props,
    int              global_index));

void
NEdelete_obj_prop PTARGS((
    NEobj_prop_list  props,
    int              prop_index,
    int              *num_props,
    NEprop_list      global_props));

void
NEfree_obj_props PTARGS((
    NEobj_prop_list  props,
    int              num_props));

NEprop_group_list
NEget_prop_group_info PTARGS((
    int  *num_info));

unsigned int
NEget_default_prop_group PTARGS((
    NEobj_disp  *obj_disp));

int *
NEget_prop_group_indices PTARGS((
    unsigned int  group,
    unsigned int  type_group,
    NEprop_list   props,
    int           num_props,
    int           *num_indices));

int *
NEget_obj_prop_group_indices PTARGS((
    unsigned int     group,
    unsigned int     type_group,
    NEobj_prop_list  obj_props,
    int              num_obj_props,
    int              *num_indices));

int
NEget_num_prop_group_indices PTARGS((
    unsigned int  group,
    unsigned int  type_group,
    NEprop_list   props,
    int           num_props));

/* Info dialog functions */

char **
NEget_info_port_strings PTARGS((
    NEobj_disp  *obj_disp));

void
NEfree_info_port_strings PTARGS((
    NEobj_disp  *obj_disp,
    char        **port_strings));

void NEpopup_object_info PTARGS((
    NEobj_disp  *obj_disp));

/* Rename dialog functions */

void NEpopup_rename_dialog PTARGS((
    NEobj_disp  *obj_disp));

void NEhide_rename_dialog PTARGS((
    NEobj_disp  *obj_disp));

/* Object browser dialog functions */

void NEpopup_object_browser PTARGS((
    NEobj_disp  *obj_disp));

/* Menu initialization functions */

int
NEdo_copy PTARGS((
    char     *buffer_file));

int
NEdo_paste PTARGS((
    NEobj_disp  *obj_disp,
    char        *buffer_file));

/* From app_rsrc.c */

void
NEinit_app_resources PTARGS((
    NEshell_info  *shell_info));

NEapp_resource_list *
NEget_app_resources PTARGS((void));

/* From arrange.c */

void
NEgraph_arrange PTARGS((
    NEobj_disp *obj_disp,
    int        set_prop));

/* From data_obj.c */

void
NEupdate_proj_edit_state PTARGS((
    OMobj_id  obj_id));

/* From drop.c */

int
NEdrop_selected PTARGS((
    NEobj_disp  *obj_disp,
    NEobj_disp  *drop_site, 
    int          merge));

int
NEcopy_vs_reparent PTARGS((
    NEobj_disp  *obj_disp,
    NEobj_disp  *drop_site));

/* From flash.c */

void
NEset_flashing PTARGS((
    int  flag));

void
NEadd_flash_request PTARGS((
    NEobj_disp  *obj_disp));

void
NEdelete_flash_request PTARGS((
    NEobj_disp  *obj_disp));

/* From group.c */

void
NEgroup_init PTARGS((
    NEobj_disp  *obj_disp));

void
NEgroup_realize PTARGS((
    NEobj_disp  *obj_disp));

void
NEgroup_config PTARGS((
    NEobj_disp  *obj_disp));

char *
NEgroup_get_text_info PTARGS((
    NEobj_disp             *obj_disp,
    WTcoord               *text_x,
    WTcoord               *text_y,
    WTcoord               *pixmap_x,
    WTcoord               *pixmap_y,
    WTtext_justification  *justification,
    char                   *buf,
    int                    maxsize));

/* From list.c */

void
NElist_val_changed PTARGS((
    NEobj_disp  *obj_disp));

/* From maindisp.c */

void
NEinit_main_disp PTARGS((
    NEobj_disp  *obj_disp,
    OMobj_id    upper_obj,
    OMobj_id    lower_obj,
    WTcoord    upper_height));

/* From ne_util.c */

void
NEset_port_levels PTARGS((
    OMobj_id  obj_id,
    int       input,
    int       port));

OMobj_name
NEget_display_mode PTARGS((
    OMobj_id  obj_id));

void
NEset_drag_cursor PTARGS((
    NEobj_disp      *obj_disp,
    WTcursor_class  cursor_class));

void
NEget_geometry PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec,
    WTcoord     *x,
    WTcoord     *y,
    WTcoord     *w,
    WTcoord     *h));

WTpixel
NEget_standard_pixel PTARGS((
    WTdisp           *disp,
    NEstandard_color  color_index));

char *
NEget_translated_string PTARGS((
    NEtranslation_index  index));

WTdecor_ptr
NEget_default_decor PTARGS((
    NEobj_disp  *obj_disp));

NEobj_disp*
NEfind_descendant_obj_disp PTARGS((
    NEobj_disp  *obj_disp,
    OMobj_id    descendant_id));

void
NEadd_subobj_callback PTARGS((
    OMobj_id            obj_id,
    char                *subobj_name,
    char                *callback_name,
    NEom_callback_func  callback_func,
    void                *callback_data,
    OMobj_id            callback_obj_id));

OMobj_id
NEget_data_obj PTARGS((
    OMobj_id  obj_id));

NEshell_info *
NEget_shell_info PTARGS((
    OMobj_id  obj_id));

void
NEset_error_handler PTARGS((
    NEshell_info  *shell_info));

void
NEclear_error_handler PTARGS((
    NEshell_info  *shell_info));

void
NEhide_dialogs PTARGS((
    NEobj_disp  *obj_disp));

/* From network.c */

void
NEupd_refs PTARGS((
    NEobj_disp  *sub_disp));

/* From obj_disp.c */

void
NEmake_config_request PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec));

void
NEobj_disp_val_changed PTARGS((
    NEobj_disp  *obj_disp));

void
NEconfig_obj_disp PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec));

int
NEget_port_from_xy PTARGS((
    NEobj_disp  *obj_disp,
    WTcoord     x,
    WTcoord     y,
    int         *inout,
    int         *port,
    int         *inside));

WTdecor_ptr
NEget_obj_disp_decor PTARGS((
    NEobj_disp  *obj_disp,
    WTdisp     *disp));

void
NEinit_maximized_obj_disp PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec));

void
NEinit_unmaximized_obj_disp PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec));

void
NEvalidate_cache PTARGS((
    NEobj_disp   *obj_disp));

void
NEinvalidate_cache PTARGS((
    NEobj_disp   *obj_disp));

/* From obj_info.c */

int NEcan_close PTARGS((NEobj_disp *obj_disp));
int NEcan_open PTARGS((NEobj_disp *obj_disp));
int NEis_opened PTARGS((NEobj_disp *obj_disp));
int NEis_showing_params PTARGS((NEobj_disp *obj_disp));
int NEcan_show_params PTARGS((NEobj_disp *obj_disp));
int NEcan_rename PTARGS((NEobj_disp *obj_disp));
int NEcan_obj_reference_others PTARGS((OMobj_id obj_id));

int NEcan_minimize PTARGS((NEobj_disp *obj_disp));

int NEis_minimized PTARGS((NEobj_disp *obj_disp));

int NEcan_maximize PTARGS((NEobj_disp *obj_disp));

int NEget_maximization PTARGS((NEobj_disp *obj_disp));

int NEcan_move PTARGS((NEobj_disp *obj_disp));

int NEcan_size PTARGS((NEobj_disp *obj_disp));

int NEhas_siblings PTARGS((NEobj_disp *obj_disp));

int NEis_obj_open PTARGS((
    OMobj_id  obj_id));

int NEis_open PTARGS((
    NEobj_disp  *obj_disp));

int NEis_obj_library_type PTARGS((
    OMobj_id  obj_id));

int NEis_library_type PTARGS((
    NEobj_disp  *obj_disp));

int NEis_flibrary_type PTARGS((
    NEobj_disp  *obj_disp));

int NEis_editable PTARGS((
    NEobj_disp  *obj_disp));

int NEis_loadable PTARGS((
    NEobj_disp  *obj_disp));

int NEcan_resize PTARGS((
    NEobj_disp  *obj_disp));

int NEcan_edit_props PTARGS((
    NEobj_disp  *obj_disp));

int NEcan_edit_ports PTARGS((
    NEobj_disp  *obj_disp));

int
NEis_expanded PTARGS((NEobj_disp *obj_disp));

int
NEis_selected PTARGS((NEobj_disp *obj_disp));

int
NEis_visible PTARGS((NEobj_disp *obj_disp));

int
NEis_group_array PTARGS((NEobj_disp *obj_disp));

int
NEcan_edit_value PTARGS((NEobj_disp *obj_disp));

int NEis_obj_link PTARGS((
    OMobj_id  obj_id));

int
NEis_link PTARGS((NEobj_disp *obj_disp));

int NEnum_subobjs PTARGS((
    NEobj_disp  *obj_disp));

int NEis_scratch_pad PTARGS((
    NEobj_disp  *obj_disp));

int
NEin_scratch_pad PTARGS((
    NEobj_disp  *obj_disp));

int
NEis_array_of_group_refs PTARGS((
    NEobj_disp  *obj_disp));

int
NEsubobjs_readonly PTARGS((
    NEobj_disp  *obj_disp));

int
NEis_connected_group_ref PTARGS((
    NEobj_disp  *obj_disp));

int
NEis_array PTARGS((
    NEobj_disp  *obj_disp));

/* From oe.c */

int 
OEget_obj_ref PTARGS((
    OMobj_id  obj_id,
    OMobj_id  *ref_id));

int
OEset_int_val_same PTARGS((
    OMobj_id  obj_id,
    char      *name_str,
    int       value));

/* From popup.cxx */

void
NEprocess_popup_selection PTARGS((
    NEobj_disp  *obj_disp,
    int         active_id));

/* From port.c */

void
NEport_press PTARGS((
    NEobj_disp  *obj_disp,
    int         inout,
    int         port_index,
    int         inside));

void
NEport_motion PTARGS((
    NEobj_disp  *obj_disp,
    WTevent     *event,
    int         in_parent));

void
NEport_release PTARGS((
    NEobj_disp  *obj_disp));

/* From stat.c */

NEstate_ptr
NEcreate_state PTARGS(());

void
NEdestroy_state PTARGS((
    NEstate_ptr  state));

void
NEadd_selected_obj PTARGS((
    NEstate_ptr  state,
    NEobj_disp   *obj_disp));

int
NEis_selected_obj PTARGS((
    NEstate_ptr  state,
    NEobj_disp   *obj_disp));

void
NEdelete_selected_obj PTARGS((
    NEstate_ptr  state,
    NEobj_disp   *obj_disp));

void
NEclear_selected_objs PTARGS((
    NEstate_ptr  state));

void
NEadd_shell_info PTARGS((
    NEstate_ptr   state,
    NEshell_info  *shell_info));

void
NEdelete_shell_info PTARGS((
    NEstate_ptr   state,
    NEshell_info  *shell_info));

void
NEupdate_menubars PTARGS((
    NEstate_ptr  state));

NEobj_disp *
NEget_single_selected_obj PTARGS((
    NEstate_ptr  state));

/* From tmp_util.cxx */

void
NEupdate_status_bar PTARGS((
    NEobj_disp  *obj_disp,
    char        *string));

/* From val.c */

int
NEval_init PTARGS((
    NEobj_disp   *obj_disp,
    NEgeom_spec  *geom_spec,
    int          request_config));

int
NEval_cleanup PTARGS((
    NEobj_disp      *obj_disp,
    NEcleanup_mode  mode));

void
NEval_realize PTARGS((
    NEobj_disp  *obj_disp));

void
NEval_val_changed PTARGS((
    NEobj_disp  *obj_disp));

void
NEval_config PTARGS((
    NEobj_disp  *obj_disp));

/* From wind.c */

void
NEwind_val_changed PTARGS((
    NEobj_disp  *obj_disp));

/* UNIX/NT-specific functions */

#ifdef MSDOS

BOOL WINAPI
BrowserDlgProc PTARGS((HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam));

BOOL WINAPI
ElemInfoDlgProc PTARGS((HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam));

#else

XmString
NEget_translated_xmstring PTARGS((
    NEtranslation_index  index));

void
NEcenter_widget PTARGS((
    Widget  w));

void NEadd_wm_del_handler PTARGS((Widget  w));

#endif

#ifdef __cplusplus
}  /* End extern "C" */
#endif

/*--------------------------------------------------------------------*/

#endif /* _NE_H_INCLUDED */
/* DON'T ADD ANYTHING AFTER THIS #endif */
